<?php
/*
Plugin Name: Simply Instagram
Plugin URI: http://rollybueno.info/project/simply-instagram
Description: Promote your Instagram photo through your Wordpress website using Simply Instagram.
Version: 1.0.4
Author: Rolly G. Bueno Jr.
Author URI: http://www.rollybueno.info
License: GPL v2.0.
    Copyright 2012 Rolly G. Bueno Jr.
*/
DEFINE( "simplyInstagramPluginPath", plugin_dir_path(__FILE__)  );
require simplyInstagramPluginPath . 'simplyInstagramFunctions.php';
require simplyInstagramPluginPath . 'simplyInstagramWidget.php';
/**
 * Plugin installation
*/
function simply_instagram_install()
{
    global $wpdb;
    $table = $wpdb->prefix . "instagram";
	if($wpdb->get_var("show tables like '$table'") != $table) {
	    $sql = "CREATE TABLE " . $table . " (
	    				  access_token varchar(150) COLLATE utf8_unicode_ci NOT NULL,
	    				  user_id varchar(50) COLLATE utf8_unicode_ci NOT NULL,
	    				  ID int(11) NOT NULL AUTO_INCREMENT,
	    				  PRIMARY KEY ( ID )
					)";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	    dbDelta($sql);
	}
}
/**
 * Uninstall, drop table
*/

function simply_instagram_uninstall()
{
	global $wpdb;
        $table = $wpdb->prefix."instagram";
        
        $wpdb->query("DROP TABLE IF EXISTS $table");
}
/**
 * hook registration
*/
register_activation_hook(__FILE__,'simply_instagram_install');
register_deactivation_hook( __FILE__, 'simply_instagram_uninstall' );

/**
 * admin menu
*/
function register_custom_menu_page() 
{
	add_options_page('Simply Instagram', 'Simply Instagram', 'manage_options', 'simply-instagram', 'option_page_simply_instagram' );		 
}
add_action( 'admin_menu', 'register_custom_menu_page' );

function option_page_simply_instagram()
{
	global $wpdb;
	
	/*
	 * Info query to check if database
	 * has record.
	*/
	$info = $wpdb->get_results("select * from " . $wpdb->prefix . "instagram");
	
	echo '<div class="wrap">';
	echo '<div id="icon-plugins" class="icon32"></div><h2>WP Instagram</h2>';
	
	switch( $_GET['a'] ):
		/**
		 * Only accept add-token 
		 * value for param a.
		*/
		case'add-token':
			/**
			 * Check if info query returns value
			*/
			if( !$info ):
				/**
				 * If no value return,
				 * insert access token and user ID
				*/
				$wpdb->insert( $wpdb->prefix . "instagram", array( 'access_token' => $_POST['access_token'], 'user_id' => $_POST['id'] ) );
				echo '<div id="message" class="updated fade"><p><strong>Instagram access token and id successfully saved! Click <a href="options-general.php?page=simply-instagram">HERE</a> to proceed</strong></p></div>';				
			else:
				/**
				 * Info query returns value
				 * use update only.
				*/
				echo '<div id="message" class="updated fade"><p><strong>Instagram access token and id successfully edited! Click <a href="options-general.php?page=simply-instagram">HERE</a> to proceed</strong></p></div>';
				$wpdb->update( $wpdb->prefix . "instagram", array( 'access_token' => $_POST['access_token'], 'user_id' => $_POST['id'] ), array( 'ID' => $_POST['ID'] ) ) or die(mysql_error());		
			endif;			
		break;
		/**
		 * if param a is not set,
		 * show the form.
		*/
		default:
			?>
				<form method="post" action="options-general.php?page=simply-instagram&a=add-token">
				    <table width="25%">
		        		<tr><td><label for="access_token">Access Token: </label></td><td><input id="access_token" name="access_token" value="<?php echo $info[0]->access_token; ?>" /><input id="ID" name="ID" value="<?php echo $info[0]->ID; ?>" type="hidden" /></td></tr>
		        		<tr><td><label for="id">ID: </label></td><td><input id="id" name="id" value="<?php echo $info[0]->user_id; ?>" /></td></tr>
		    		</table>
				    <i>How to get these info? Kindly go <a href="http://rollybueno.info/wordpress/wp-plugin/instagram/instagram-user-permission" target="_blank">here</a> and follow the instructions.</i><br/>
				    <input class="button-primary" type="submit" name="Save" value="Save Instagram Data" id="submitbutton" />
				</form> 
			<?php
		break;
		
	endswitch;
	echo '</div>';
}

/**
* instagram shorcode. It will provide several options
*/
function simply_instagram_sc( $atts )
{
	/**
	 * shortcode standard:
	 * [simply_instagram endpoints="" type="" display="" ]
	 * Endpoints:
	 	users:
	 	 *type
	 		self-feed
	 		recent-media
	 		likes
	 	media
	 	 *type
	 		popular
	*/
	extract( shortcode_atts( array( ), $atts ) );
	
	switch( $atts['endpoints'] ):
		
		/**
		 * Users endpoints
		*/
		case'users':
			/**
			 * endpoints type:
			 * self-feed
			 * recent media
			 * likes
			*/
			switch( $atts['type'] ):
				/**
				 * Self-feed
				 * Display all photos uploaded by user
				 * with user's following
				*/
				case'self-feed':
					$customRel = "sIntSelfFeedSC";
					echo sInstDisplayData( sInstGetSelfFeed( access_token() ), $atts['size'], $atts['display'], $atts['width'], $customRel );					
				break;
				/**
				 * Recent Media
				 * Display all photos uploaded by user only
				*/
				case'recent-media':
					$customRel =  "sIntRecentMediaSC";
					echo sInstDisplayData( sInstGetRecentMedia( user_id(), access_token() ), $atts['size'], $atts['display'], $atts['width'], $customRel );
				break;
				/**
				 * Likes
				 * Display all photos liked by user
				*/
				case'likes':
					$customRel = "sIntLikesSC";
					echo sInstDisplayData( sInstGetLikes( access_token() ), $atts['size'], $atts['display'], $atts['width'], $customRel );					
				break;
				
			endswitch;
			
		break;
		/**
		 * Media endpoints
		*/
		case'media':
			/**
			 * Media endpoint only accept currently
			 * trending photos in Instagram
			*/
			$customRel = "sIntMediaPopularSC";
			echo sInstDisplayData( sInstGetMostPopular( $atts['type'], access_token() ), $atts['size'], $atts['display'], $atts['width'], $customRel );				
		break;
		
	endswitch;
	/**
	 * PrettyPhoto settings for shortcode.
	*/
	?>
	<script type="text/javascript" charset="utf-8">
	  jQuery(document).ready(function(){
	    jQuery("a[rel^='<?php echo $customRel; ?>']").prettyPhoto({
	    	autoplay_slideshow: <?php echo $atts[ 'auto_play' ];?>,
	    	social_tools: false,
	    	theme: '<?php echo $atts[ 'theme' ]; ?>',
	    	});
	  });
	</script>
	<?php	
			
}
/**
* Register with instagram shortcode
*/
add_shortcode( 'simply_instagram', 'simply_instagram_sc' );

/**
* Enqueue plugin style-file
*/
function simply_instagram_stylesheet() 
{      
	wp_register_style( 'simplyInstagram', plugins_url('css/simplyInstagram.css', __FILE__) );
        wp_enqueue_style( 'simplyInstagram' );
	
        wp_register_style( 'prettyPhoto', plugins_url('css/simply-instagram-prettyPhoto.css', __FILE__) );
        wp_enqueue_style( 'prettyPhoto' );
}
/**
* Register with hook 'wp_enqueue_scripts', 
* which can be used for front end CSS and JavaScript
*/
add_action( 'wp_enqueue_scripts', 'simply_instagram_stylesheet' );

/**
* Enqueue plugin script
*/
function simply_instagram_script()
{
  	/**
	 * jquery prettyphoto js
	 * v 3.1.4
	*/
    	wp_enqueue_script( 'jquery-prettyphoto-3.1.4', plugins_url( '/js/simply-instagram-jquery.prettyPhoto.js',__FILE__ ), array(), '3.1.4' );    	
}
add_action('wp_enqueue_scripts', 'simply_instagram_script');

?>