<?php

/** 
 * SHow info
 * name
 * bio
 * website
 * followers
 * following
 * profile_pic
 * instagram page
*/
function sInstShowInfo( $data, $args=array(), $width="150" )
{
	$infos = '<div class="simplyInstagram-profile">';
	
	if( $args['profile_pic'] == "true" ):
		$infos .= '<div class="profile-data"><img src="' . $data['data']['profile_picture'] . '" style="width: ' . $width . 'px;"/></div>';	
	endif;
	
	if( $args['name'] == "true" ):
		$infos .= '<div class="profile-data"><h1>' . $data['data']['full_name'] . '</h1></div>';
	endif;
	
	if( $args['bio'] == "true" ):
		$infos .= '<div id="profile-bio">' . $data['data']['bio'] . '</div>';
	endif;
	
	if( $args['website'] == "true" ):
		$infos .= '<div class="profile-data"><a href="' . $data['data']['website'] . '" target="_blank" />' . $data['data']['website'] . '</a></div>';
	endif;
		$infos .= '<div class="data-holder">';
	if( $args['media'] == "true" ):
		$infos .= '<span class="profile-media">' . $data['data']['counts']['media'] . '<div class="profile-media-content">Photo</div></span>';
	endif;
	
	if( $args['followers'] == "true" ):
		$infos .= '<span class="profile-media">' . $data['data']['counts']['followed_by'] . '<div class="profile-media-content">Followers</div></span>';
	endif;
	
	if( $args['following'] == "true" ):
		$infos .= '<span class="profile-media">' . $data['data']['counts']['follows'] . '<div class="profile-media-content">Followings</div></span>';
	endif;
		$infos .= '</div>';
	$infos .= '</div>';
	
	echo $infos;
}

/**
* Get self feed
*/
function sInstGetSelfFeed( $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/self/feed?access_token=" . $access_token ;
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;
}

/**
* Show data in widget form
*/
function sInstShowWidgetData( $data, $count='9', $width='75', $customRel="sIntWidget" )
{
	/**
	 * Determine query return
	 * next query used to avoid
	 * blank return when display value is 
	 * greater than API return
	*/
	
	if( count( $data['data'] ) > $count ):
		$query = $count;
	else:
		$query = count( $data['data'] );
	endif;
	
 	for( $i = 0; $i < $query; $i++ ):
		$output = '<a href="' . $data['data'][$i]['images']['standard_resolution']['url'] . '" rel="' . $customRel . '[instagram]" title="' . htmlspecialchars( $data['data'][$i]['caption']['text'], ENT_QUOTES ). '">';
			$output .= '<div class="si-content" style=" display: none; margin: 10px; "><br/><br/>' . htmlspecialchars( $data['data'][$i]['caption']['text'], ENT_QUOTES ). '<br/><br/>';
			$output .= '<div class="content-info"><img class="front-photo" src="' . $data['data'][$i]['caption']['from']['profile_picture'] . '" width="15px"/>' . $data['data'][$i]['caption']['from']['username'] . '</div>'; 
			$output .= '<div class="content-info"><img src="' . plugins_url('/simply-instagram/images/instagram-like.png') . '" width="19px" style="vertical-align: middle;" /> ' . $data['data'][$i]['likes']['count'] . '</div>';
			$output .= '<div class="content-info"><img src="' . plugins_url('/simply-instagram/images/instagram-comment.png') . '" width="19px" style="vertical-align: middle;" /> ' . $data['data'][$i]['comments']['count'] . '</div>';
			$output .= '<br/><br/><br/><br/></div>';
			$output .= '<img class="front-photo" src="' . $data['data'][$i]['images']['low_resolution']['url'] . '" width="' . $width .'px" title="' . $data['data'][$i]['caption']['text'] . '">';
			$output .= "</a>";
						
			echo $output;		
	endfor;
}

/**
 * Check if access token exist
 * return null otherwise
*/
function access_token()
{
	global $wpdb;
	
	$getAccessToken = $wpdb->get_results("select * from " . $wpdb->prefix . "instagram");
	if( $getAccessToken ):
		return $getAccessToken[0]->access_token;
	else:
		return null;
	endif;
}

/**
 * Check if user_is exist
 * return null otherwise
*/
function user_id()
{
	global $wpdb;
	
	$getUserID = $wpdb->get_results("select * from " . $wpdb->prefix . "instagram");
	if( $getUserID ):
		return $getUserID[0]->user_id;
	else:
		return null;
	endif;
}

/**
* Get the list of users this user follows.
*/
function sInstGetFollowing( $user_id, $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/" . $user_id . "/follows?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}


/**
* Get the list of users this user is followed by.
*/
function sInstGetFollowers( $user_id, $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/" . $user_id . "/followed-by?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
 * See the authenticated user's list of media they've liked. 
 * Note that this list is ordered by the order in which the user liked the media. 
 * Private media is returned as long as the authenticated user has permission to view that media. 
 * Liked media lists are only available for the currently authenticated user.
*/
function sInstGetLikes( $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/self/media/liked?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
* Get the most recent media published by a user.
*/
function sInstGetRecentMedia( $user_id, $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/" . $user_id . "/media/recent/?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
* See the authenticated user's feed.
*/
function simply_instagram_get_feed( $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/self/feed?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
* Get basic information about a user.
*/
function sInstGetInfo( $user_id, $access_token )
{
	$apiurl = "https://api.instagram.com/v1/users/" . $user_id . "/?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
* most-popular.
*/
function sInstGetMostPopular( $media, $access_token )
{
	$apiurl = "https://api.instagram.com/v1/media/" . $media . "?access_token=" . $access_token;
	
	$response = wp_remote_get( $apiurl );
	$data = json_decode( $response['body'], true );
	
	return $data;	
}

/**
* Show most popular randomly. Im using lightbox for viewing each photo.
* htmlspecialchars() is used to filter caption text with illegal
* char that may cause display bug.
*/
function sInstDisplayData( $data, $size='low_resolution', $display="20", $width="150", $customRel="sIntWid" )
{	
	/**
	 * Determine query return
	 * next query used to avoid
	 * blank return when display value is 
	 * greater than API return
	*/
	
	if( count( $data['data'] ) > $display ):
		$query = $display;
	else:
		$query = count( $data['data'] );
	endif;
		for( $i=0; $i < $query; $i++ ):
						
			$output = '<a href="' . $data['data'][$i]['images'][$size]['url'] . '" rel="' . $customRel . '[instagram]" title="' . htmlspecialchars( $data['data'][$i]['caption']['text'], ENT_QUOTES ). '">';
			$output .= '<div class="si-content" style=" display: none; margin: 10px; "><br/><br/><i>' . htmlspecialchars( $data['data'][$i]['caption']['text'], ENT_QUOTES ). '</i><br/><br/>';
			$output .= '<div class="content-info"><img class="front-photo" src="' . $data['data'][$i]['caption']['from']['profile_picture'] . '" width="15px"/>' . $data['data'][$i]['caption']['from']['username'] . '</div>'; 
			$output .= '<div class="content-info"><img src="' . plugins_url('/simply-instagram/images/instagram-like.png') . '" width="19px" style="vertical-align: middle;" /> ' . $data['data'][$i]['likes']['count'] . '</div>';
			$output .= '<div class="content-info"><img src="' . plugins_url('/simply-instagram/images/instagram-comment.png') . '" width="19px" style="vertical-align: middle;" /> ' . $data['data'][$i]['comments']['count'] . '</div>';
			$output .= '<br/><br/><br/><br/></div>';
			$output .= '<img class="front-photo" src="' . $data['data'][$i]['images']['low_resolution']['url'] . '" width="' . $width . 'px" title="' . $data['data'][$i]['caption']['text'] . '">';
			$output .= "</a>";
			
			echo $output;
		endfor;
}

function sInstDiplayFollowData( $data, $display="20", $width="150", $showFollowerData = false )
{
	/**
	 * Determine query return
	 * next query used to avoid
	 * blank return when display value is 
	 * greater than API return
	*/
	
	if( count( $data['data'] ) > $display ):
		$query = $display;
	else:
		$query = count( $data['data'] );
	endif;
		for( $i=0; $i < $query; $i++ ):
			/**
			 * Check if user wanted to
			 * include info of followers
			 * or whom they following
			*/
			if( $showFollowerData == true ):
			
				//$output = sInstShowInfo( sInstGetInfo( $data['data'][$i]['id'], access_token() ), array( 'name' => 'true', 'bio' => 'true', 'website' => 'true', 'media' => 'true', 'followers' => 'true', 'following' => 'true', 'profile_pic' => 'true' ), $width );
			
			else:
						
				//$output = '<div id="tooltip-division" style=" width: ' . $width . 'px; float: left; margin: 5px; overflow: auto;">';
				$output = '<img class="front-photo" src="' . $data['data'][$i]['profile_picture'] . '" width="' . $width . 'px" title="' . $data['data'][$i]['full_name'] . '">';				
				//$output .= '</div>';
			
			endif;
						
			echo $output;	
		endfor;		
}

?>